#!/usr/local/bin/perl
##############################################################################
# Magic Packet Web Forwarder Ver.1.02
#
#
# Copyright (C) 2009-2015 Software Factory. All rights reserved.
##############################################################################
use Socket;

# Port number
$DEFAULT_PORT = 2304;



if($ENV{"REQUEST_METHOD"} eq "POST"){
	read(STDIN, $buffer, $ENV{"CONTENT_LENGTH"});
}
else{
	$buffer = $ENV{'QUERY_STRING'};
}

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
}

$macaddr = $FORM{'MAC'};

foreach (split /-/, $macaddr) {
  $packet .= chr(hex($_));
}
$packet = chr(0xFF) x 6 . $packet x 16;

# $remoteaddr = gethostbyname($FORM{'IP'});
$remoteaddr = inet_aton($FORM{'IP'});

$sock_addr = pack_sockaddr_in($DEFAULT_PORT, $remoteaddr);
$proto = getprotobyname('udp');

socket(S, AF_INET, SOCK_DGRAM, $proto) or die "socket : $!";
setsockopt(S, SOL_SOCKET, SO_BROADCAST, 1) or die "setsockopt : $!";
send(S, $packet, 0, $sock_addr) or die "send : $!";
close S;

print "Content-type: text/html\n\n";
print "<html>";
print "<head>";
print "<title>Magic Packet Web Forwarder</title>";
print "</head>";
print "<body>";
print "<h1>Success</h1>";
print "<p>Sent Magic Packet to $FORM{'IP'} on Port $DEFAULT_PORT.</p>";
print "</body>";
print "</html>";
